TOP_DIR  ?=$(shell pwd)

CC      = arm-himix200-linux-gcc

CFLAGS := -Wall -Werror -O3
CFLAGS += -DCHIP_$(shell echo $(CHIP) | tr a-z A-Z)

OBJS = IPC_msg.o IPC_cardvInfo.o
LIB = libIPC_msg.so
STATIC_LIB = libIPC_msg.a

INCLUDE_PATH = -I$(TOP_DIR) \
               -I$(TOP_DIR)/../DCF \

all : $(LIB) $(STATIC_LIB) prepare

prepare :
	-clang-format -i *.c *.h

%.o : %.c prepare
	@echo "compile $<"
	@$(CC) $(CFLAGS) -fpic -c $< -o $@ $(INCLUDE_PATH)

$(LIB) : $(OBJS)
	rm -f $@
	$(CC) -shared -o $@ $(OBJS)

$(STATIC_LIB) : $(OBJS)
	rm -f $@
	$(AR) -r $@ $(OBJS)

clean:
	rm -f $(OBJS) $(LIB) $(STATIC_LIB)

install:
	cp $(LIB) $(PROJECT_DIR)/release/chip/$(CHIP)/$(PRODUCT)/common/$(TOOLCHAIN)/$(TOOLCHAIN_VERSION)/3rd_party_libs/dynamic
	cp $(STATIC_LIB) $(PROJECT_DIR)/release/chip/$(CHIP)/$(PRODUCT)/common/$(TOOLCHAIN)/$(TOOLCHAIN_VERSION)/3rd_party_libs/static